ORG 100h
CALL FindSMBusAddr
MOV  AX,[SMBusAddr]
CMP  AX,0
JNZ  .SMBusFound    
MOV  AH,9
MOV  DX,str_SMbusNotFound
INT  21h
RET ;    

.SMBusFound:
MOV  ESI,str_SMBusAddr+11
CALL WordToHEX

MOV  AH,9
MOV  DX,str_SMBusAddr
INT  21h

MOV  ECX,4
MOV  BL,53h
.Loop3:

MOV  AL,BL
CALL TestSMBusDevice
TEST AL,1
JNZ  .ok
MOV  ESI,str_SPD0NotFound+4
MOV  AL, BL
CALL ByteToHEX
MOV  AH,9
MOV  DX,str_SPD0NotFound
INT  21h

JMP .Next
.ok:

MOV  ESI, SPD
MOV  AL, BL
CALL Read256ByteSMBus

MOV  ESI,str_SPD0Found+4
MOV  AL, BL
CALL ByteToHEX

XOR  EAX,EAX
MOV  AL,[SPD+2]
MOV  ESI,str_Memory_Type_
MOV  EDI,CASE_1
CALL CopyCase


XOR  EAX,EAX
MOV  AL,[SPD+20]
CMP  AL,0
JZ  .Zero
MOV  AH,1
.Loop2:
MOV  BH,AL
SHR  AL,1
INC  AH
TEST BH,1
JNZ  .Loop2

.Zero:
MOV  AL,AH
XOR  AH,AH
MOV  ESI,str_DIMM_Type_
MOV  EDI,CASE_2
CALL CopyCase


XOR  EAX,EAX
MOV  AL,[SPD+12]
AND  AL, 7Fh
MOV  ESI,str_Refresh_Rate_
MOV  EDI,CASE_3
CALL CopyCase

XOR  EAX,EAX
MOV  AL,[SPD+8]
MOV  ESI,str_Signal_Levels_
MOV  EDI,CASE_4
CALL CopyCase


MOV  ESI,str_Row_Address_Bits_
MOV  AL, [SPD+3]
CALL ByteToStr

MOV  ESI,str_Column_Address_Bits_
MOV  AL, [SPD+4]
CALL ByteToStr

MOV  ESI,str_Module_Rows_
MOV  AL, [SPD+5]
CALL ByteToStr

MOV  ESI,str_Module_Data_Width_
MOV  AX, Word [SPD+6]
CALL ByteToStr


MOV  AH,9
MOV  DX,Text
INT  21h
.Next:

MOV  AX,0C00h          ;   
INT  21h

MOV  AH,7
INT  21h               ;   

DEC BL
DEC ECX
JNZ .Loop3
RET  ;    


SPD db 256 dup 0               

str_FoundDivece           db 'Found Divece :',0Dh,0Ah,'$'
str_Divece                db '  ',0Dh,0Ah,'$'
str_SMBusAddr             db 'SMBusAddr :    ',0Dh,0Ah,'$'
str_SMbusNotFound         db 'SMBusAddr : Not Found',0Dh,0Ah,'$'
str_SPD0NotFound          db 'SPD#    Not Found',0Dh,0Ah,'$'
Text:
str_SPD0Found             db 'SPD#    ',0Dh,0Ah
str_Memory_Type           db 'Memory Type: '
str_Memory_Type_          db '                 ',0Dh,0Ah
str_DIMM_Type             db 'DIMM Type: '
str_DIMM_Type_            db '                 ',0Dh,0Ah
str_Refresh_Rate          db 'Refresh Rate: '
str_Refresh_Rate_         db '                 ',0Dh,0Ah
str_Signal_Levels         db 'Signal Levels: '
str_Signal_Levels_        db '              ',0Dh,0Ah

str_Row_Address_Bits      db 'Row Address Bits: '
str_Row_Address_Bits_     db '   ',0Dh,0Ah
str_Column_Address_Bits   db 'Column Address Bits: '
str_Column_Address_Bits_  db '   ',0Dh,0Ah
str_Module_Rows           db 'Module Rows: '
str_Module_Rows_          db '   ',0Dh,0Ah
str_Module_Data_Width     db 'Module Data Width: '
str_Module_Data_Width_    db '      ',0Dh,0Ah

                          db '$'

CASE_1                    dd 9,CASE_1_01-CASE_1_00,CASE_1_00,CASE_1_01,CASE_1_02,CASE_1_03,CASE_1_04,CASE_1_05,CASE_1_06,CASE_1_07,CASE_1_08

CASE_1_00                 db '            '
CASE_1_01                 db 'FPM DRAM         '
CASE_1_02                 db 'EDO              '
CASE_1_03                 db 'Pipelined Nibble '
CASE_1_04                 db 'SDRAM            '
CASE_1_05                 db 'ROM              '
CASE_1_06                 db 'DDR SGRAM        '
CASE_1_07                 db 'DDR SDRAM        '
CASE_1_08                 db 'DDR2 SDRAM       '

CASE_2                    dd 7,CASE_2_01-CASE_2_00,CASE_2_00,CASE_2_01,CASE_2_02,CASE_2_04,CASE_2_08,CASE_2_10,CASE_2_20

CASE_2_00                 db '            '
CASE_2_01                 db 'RDIMM            '
CASE_2_02                 db 'UDIMM            '
CASE_2_04                 db 'SO-DIMM          '
CASE_2_08                 db 'Micro-DIMM       '
CASE_2_10                 db 'Mini-RDIMM       '
CASE_2_20                 db 'Mini-UDIMM       '

CASE_3                    dd 6,CASE_3_01-CASE_3_00,CASE_3_00,CASE_3_01,CASE_3_02,CASE_3_03,CASE_3_04,CASE_3_05

CASE_3_00                 db 'Normal 15.625 us '
CASE_3_01                 db 'Reduced 3.9 us   '
CASE_3_02                 db 'Reduced 7.8 us   '
CASE_3_03                 db 'Extended 31.3 us '
CASE_3_04                 db 'Extended 62.5 us '
CASE_3_05                 db 'Extended 125 us  '

CASE_4                    dd 6,CASE_4_01-CASE_4_00,CASE_4_00,CASE_4_01,CASE_4_02,CASE_4_03,CASE_4_04,CASE_4_05

CASE_4_00                 db '5.0 Volt/TTL  '
CASE_4_01                 db 'LVTTL         '
CASE_4_02                 db 'HSTL 1.5 Volt '
CASE_4_03                 db 'SSTL 3.3 Volt '
CASE_4_04                 db 'SSTL 2.5 Volt '
CASE_4_05                 db 'SSTL 1.8 Volt '


include "FindSMBus.inc"    
;********************************************
;*             *
;*  AL,    SMBus          *
;*   EAX =1  0             *
;********************************************
TestSMBusDevice:
PUSH EDX
PUSH ECX
MOV  DX, [SMBusAddr]
ADD  DX, 4           ;+4   XMIT_SLVA
SHL  AL, 1
OR   AL, 1           ; 
OUT  DX, AL

NEWIODELAY
DEC  DX              ;+3 HST_CMD  ,  EEPROM   
XOR  AL,AL
OUT  DX,AL
NEWIODELAY

DEC  DX              ;+2   HST_CNT
MOV  AL, 01001000b   ;START=1 SMB_CMD =010b Byte Data 
OUT  DX, AL

XOR  EAX,EAX


SUB  DX, 2           ;+0   HST_STS
;MOV  CX, 03D00h      ;    0.0078125    128  2   32768 /
MOV  CX, 0800h      ;    0.0012207     40  2   32768 /
.Loop:
NEWIODELAY
IN   AL, DX
TEST AL, 2
JNZ  .ok
LOOP .Loop 
                    ;   
ADD  DX,2
MOV  AL,2           ;  Kill 
OUT  DX,AL

SUB  DX,2
IN   AL, DX 

.ok:
NEWIODELAY
OUT  DX, AL          ;   


AND  AL, 02H         ;INTR   ?
SHR  AL, 1           ;     
POP  ECX
POP  EDX
RET

;********************************************
;*                        *
;*  AL,    SMBus          *
;*  AH,  EEPROM                 *
;*   EAX                          *
;********************************************
ReadByteSMBus:

PUSH EDX
PUSH ECX
MOV  DX, [SMBusAddr]
ADD  DX, 4           ;+4   XMIT_SLVA
SHL  AL, 1
OR   AL, 1           ; 
OUT  DX, AL

NEWIODELAY
DEC  DX              ;+3 HST_CMD  ,  EEPROM   
MOV  AL,AH
OUT  DX,AL
NEWIODELAY

DEC  DX              ;+2   HST_CNT
MOV  AL, 01001000b   ;START=1 SMB_CMD =010b Byte Data 
OUT  DX, AL


SUB  DX, 2           ;+0   HST_STS
MOV  CX, 0800h       ;    0.0012207     40  2   32768 /
.Loop:
NEWIODELAY
IN   AL, DX
TEST AL, 2
JNZ  .ok
LOOP .Loop 
                    ;   
ADD  DX,2
MOV  AL,2           ;  Kill 
OUT  DX,AL

SUB  DX,2
IN   AL, DX 

.ok:
NEWIODELAY
OUT  DX, AL          ;   

XOR  EAX,EAX      

ADD  DX, 5           ;+5 Data0
IN   AL, DX

POP  ECX
POP  EDX
RET

;********************************************
;*                        *
;*  AL,    SMBus          *
;*  AH,  EEPROM                 *
;*   EAX                          *
;********************************************

ReadWordSMBus:

PUSH EDX
PUSH ECX
MOV  DX, [SMBusAddr]
ADD  DX, 4           ;+4   XMIT_SLVA
SHL  AL, 1
OR   AL, 1           ; 
OUT  DX, AL

NEWIODELAY
DEC  DX              ;+3 HST_CMD  ,  EEPROM   
MOV  AL,AH
OUT  DX,AL
NEWIODELAY

DEC  DX              ;+2   HST_CNT
MOV  AL, 01001100b   ;START=1 SMB_CMD =011b Word Data 
OUT  DX, AL


SUB  DX, 2           ;+0   HST_STS
MOV  CX, 0BEBh       ;      50  2   32768 /

.Loop:
NEWIODELAY
IN   AL, DX
TEST AL, 2
JNZ  .ok
LOOP .Loop 
                    ;   
ADD  DX,2
MOV  AL,2           ;  Kill 
OUT  DX,AL

SUB  DX,2
IN   AL, DX 

.ok:
NEWIODELAY
OUT  DX, AL          ;   

XOR  EAX,EAX

ADD  DX, 6           ;+6 Data0
IN   AL, DX
MOV  AH, AL
DEC  DX              ;+5 Data0
IN   AL, DX

POP  ECX
POP  EDX
RET

;********************************************
;*                        *
;*  AL,    SMBus          *
;*  AH,  EEPROM                 *
;*  EBX- .                           *
;********************************************

WritedByteSMBus:
PUSH EAX
PUSH ECX
PUSH EDX
MOV  DX, [SMBusAddr]
ADD  DX, 4           ;+4   XMIT_SLVA
SHL  AL, 1           ;  0 =0 
OUT  DX, AL

NEWIODELAY
DEC  DX              ;+3 HST_CMD  ,  EEPROM   
MOV  AL,AH
OUT  DX,AL
NEWIODELAY

ADD  DX, 2           ;+5 Data0
MOV  AL, BL
OUT  DX, AL

NEWIODELAY


SUB  DX, 3           ;+2   HST_CNT
MOV  AL, 01001000b   ;START=1 SMB_CMD =010b Byte Data 
OUT  DX, AL


SUB  DX, 2           ;+0   HST_STS
MOV  CX, 0800h       ;    0.0012207     40  2   32768 /
.Loop:
NEWIODELAY
IN   AL, DX
TEST AL, 2
JNZ  .ok
LOOP .Loop 
                    ;   
ADD  DX,2
MOV  AL,2           ;  Kill 
OUT  DX,AL

SUB  DX,2
IN   AL, DX 

.ok:
NEWIODELAY
OUT  DX, AL          ;   


POP  EDX
POP  ECX
POP  EAX
RET

;********************************************
;*                        *
;*  AL,    SMBus          *
;*  AH,  EEPROM                 *
;*  EBX- .                           *
;********************************************

WriteWordSMBus:

PUSH EAX
PUSH ECX
PUSH EDX
MOV  DX, [SMBusAddr]
ADD  DX, 4           ;+4   XMIT_SLVA
SHL  AL, 1           ;  0 =0 
OUT  DX, AL

NEWIODELAY
DEC  DX              ;+3 HST_CMD  ,  EEPROM   
MOV  AL,AH
OUT  DX,AL
NEWIODELAY

ADD  DX, 2           ;+5 Data0 +6 Data1
MOV  AX, BX
OUT  DX, AX
NEWIODELAY

SUB  DX, 3           ;+2   HST_CNT
MOV  AL, 01001100b   ;START=1 SMB_CMD =011b Word Data 
OUT  DX, AL


SUB  DX, 2           ;+0   HST_STS
MOV  CX, 0BEBh       ;      50  2   32768 /

.Loop:
NEWIODELAY
IN   AL, DX
TEST AL, 2
JNZ  .ok
LOOP .Loop 
                    ;   
ADD  DX,2
MOV  AL,2           ;  Kill 
OUT  DX,AL

SUB  DX,2
IN   AL, DX 

.ok:
NEWIODELAY
OUT  DX, AL          ;   

POP  EDX
POP  ECX
POP  EAX
RET

;********************************************
;*   256 EEPROM            *
;*  AL,    SMBus          *
;*  ESI   EEPROM              *
;********************************************
Read256ByteSMBus:
PUSH EAX
PUSH EBX
PUSH ECX
PUSH ESI
MOV  BL,AL

ADD  ESI, 0FFh
MOV  ECX, 0FFh              ;  256 
.Loop:
MOV  AL, BL
MOV  AH, CL
CALL ReadByteSMBus
MOV [ESI],AL
DEC  ESI
LOOP .Loop

MOV  AL, BL
MOV  AH, CL
CALL ReadByteSMBus
MOV [ESI],AL
DEC  ESI

POP ESI
POP ECX
POP EBX
POP EAX
RET

;********************************************
;*     HEX       *
;* EAX -                               *
;* ESI                                *
;********************************************
HEX_ASCII db '0123456789ABCDEF'
ByteToHEX:
PUSH EAX
PUSH EBX
ADD  ESI, 1
XOR  EBX, EBX
MOV  BL,  AL
AND  EBX, 0Fh
MOV  BL,  [HEX_ASCII+EBX]
MOV  [ESI],BL
DEC  ESI

SHR  EAX, 4
MOV  BL,  AL
AND  EBX, 0Fh
MOV  BL,  [HEX_ASCII+EBX]
MOV  [ESI],BL

POP  EBX
POP  EAX
RET

WordToHEX:
PUSH EAX
PUSH EBX
ADD  ESI, 3
XOR  EBX, EBX
MOV  BL,  AL
AND  EBX, 0Fh
MOV  BL,  [HEX_ASCII+EBX]
MOV  [ESI],BL
DEC  ESI

SHR  EAX, 4
MOV  BL,  AL
AND  EBX, 0Fh
MOV  BL,  [HEX_ASCII+EBX]
MOV  [ESI],BL
DEC  ESI

SHR  EAX, 4
MOV  BL,  AL
AND  EBX, 0Fh
MOV  BL,  [HEX_ASCII+EBX]
MOV  [ESI],BL
DEC  ESI

SHR  EAX, 4
MOV  BL,  AL
AND  EBX, 0Fh
MOV  BL,  [HEX_ASCII+EBX]
MOV  [ESI],BL

POP  EBX
POP  EAX
RET

ByteToStr:
PUSH EAX
PUSH EBX

ADD  ESI,2
MOV  BL,10

XOR  AH,AH
DIV  BL
ADD  AH,'0'
MOV  [ESI],AH
DEC  ESI

XOR  AH,AH
DIV  BL
ADD  AH,'0'
MOV  [ESI],AH
DEC  ESI

XOR  AH,AH
DIV  BL
ADD  AH,'0'
MOV  [ESI],AH
DEC  ESI

POP  EBX
POP  EAX
RET

WordToStr:
PUSH EAX
PUSH EBX
PUSH EDX
ADD  ESI,4
MOV  BX,10

XOR  DX,DX
DIV  BX
ADD  DL,'0'
MOV  [ESI],DL
DEC  ESI

XOR  DX,DX
DIV  BX
ADD  DL,'0'
MOV  [ESI],DL
DEC  ESI

XOR  DX,DX
DIV  BX
ADD  DL,'0'
MOV  [ESI],DL
DEC  ESI

XOR  DX,DX
DIV  BX
ADD  DL,'0'
MOV  [ESI],DL
DEC  ESI

XOR  DX,DX
DIV  BX
ADD  DL,'0'
MOV  [ESI],DL
DEC  ESI


POP  EDX
POP  EBX
POP  EAX
RET

;********************************************
;*    Case               *
;* EAX -                               *
;* ESI                                *
;* EDI  Case                          *
;********************************************
CopyCase:
PUSH ECX
CMP EAX,[EDI]
JB .Good
MOV AL,' '
MOV ECX,[EDI+4]
XCHG EDI,ESI
REP STOSB
POP ECX
RET
.Good:
MOV  ECX,[EDI+4]
MOV  EDI,[EDI+EAX*4+8]
XCHG EDI,ESI
REP  MOVSB

POP ECX
RET