ORG 100h
CALL FindSMBusAddr
MOV  AX,[SMBusAddr]
CMP  AX,0
JNZ  .SMBusFound    
MOV  AH,9
MOV  DX,str_SMbusNotFound
INT  21h
RET ;    

.SMBusFound:
MOV  ESI,str_SMBusAddr+11
CALL WordToHEX

MOV  AH,9
MOV  DX,str_SMBusAddr
INT  21h

MOV  AH,9
MOV  DX,str_FoundDivece
INT  21h

MOV  ECX, 07Fh              ;  128 
.Loop:
MOV  AL, CL
CALL TestSMBusDevice
TEST AL,1
JZ   .Next
MOV  AL,CL
MOV  ESI,str_Divece
CALL ByteToHEX
MOV  AH,9
MOV  DX,str_Divece
INT  21h

.Next:
LOOP .Loop
RET  ;    


str_FoundDivece      db 'Found Divece :',0Dh,0Ah,'$'
str_Divece           db '  ',0Dh,0Ah,'$'
str_SMBusAddr        db 'SMBusAddr :    ',0Dh,0Ah,'$'
str_SMbusNotFound    db 'SMBusAddr : Not Found',0Dh,0Ah,'$'

include "FindSMBus.inc"
    
;********************************************
;*             *
;*  AL,    SMBus          *
;*   EAX =1  0             *
;********************************************
TestSMBusDevice:
PUSH EDX
PUSH ECX
MOV  DX, [SMBusAddr]
ADD  DX, 4           ;+4   XMIT_SLVA
SHL  AL, 1
OR   AL, 1           ; 
OUT  DX, AL

NEWIODELAY
DEC  DX              ;+3 HST_CMD  ,  EEPROM   
XOR  AL,AL
OUT  DX,AL
NEWIODELAY

DEC  DX              ;+2   HST_CNT
MOV  AL, 01001000b   ;START=1 SMB_CMD =010b Byte Data 
OUT  DX, AL

XOR  EAX,EAX

SUB  DX, 2           ;+0   HST_STS
;MOV  CX, 03D00h      ;    0.0078125    128  2   32768 /
MOV  CX, 0800h      ;    0.0012207     40  2   32768 /
.Loop:
NEWIODELAY
IN   AL, DX
TEST AL, 2
JNZ  .ok
LOOP .Loop 
                    ;   
ADD  DX,2
MOV  AL,2           ;  Kill 
OUT  DX,AL

SUB  DX,2
IN   AL, DX 

.ok:
NEWIODELAY
OUT  DX, AL          ;   

AND  AL, 02H         ;INTR   ?
SHR  AL, 1           ;     
POP  ECX
POP  EDX
RET



;********************************************
;*     HEX       *
;* EAX -                               *
;* ESI                                *
;********************************************
HEX_ASCII db '0123456789ABCDEF'
ByteToHEX:
PUSH EAX
PUSH EBX
ADD  ESI, 1
XOR  EBX, EBX
MOV  BL,  AL
AND  EBX, 0Fh
MOV  BL,  [HEX_ASCII+EBX]
MOV  [ESI],BL
DEC  ESI

SHR  EAX, 4
MOV  BL,  AL
AND  EBX, 0Fh
MOV  BL,  [HEX_ASCII+EBX]
MOV  [ESI],BL

POP  EBX
POP  EAX
RET

WordToHEX:
PUSH EAX
PUSH EBX
ADD  ESI, 3
XOR  EBX, EBX
MOV  BL,  AL
AND  EBX, 0Fh
MOV  BL,  [HEX_ASCII+EBX]
MOV  [ESI],BL
DEC  ESI

SHR  EAX, 4
MOV  BL,  AL
AND  EBX, 0Fh
MOV  BL,  [HEX_ASCII+EBX]
MOV  [ESI],BL
DEC  ESI

SHR  EAX, 4
MOV  BL,  AL
AND  EBX, 0Fh
MOV  BL,  [HEX_ASCII+EBX]
MOV  [ESI],BL
DEC  ESI

SHR  EAX, 4
MOV  BL,  AL
AND  EBX, 0Fh
MOV  BL,  [HEX_ASCII+EBX]
MOV  [ESI],BL

POP  EBX
POP  EAX
RET
